//**************************************************************************
//! @file dali_lib.c,v
//!
//! Copyright (c) 2005 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_KvƂ܂B
//! 쌠ʒmɂĂlicense.txţقǂłB
//!
//! @brief ̧قDEVICE TYPE 0Ɋւėp\DALIײ ٰ݂܂݂܂B
//!
//! ̐`̧ق͎pDoxygenɂĉ͂邱Ƃł܂B
//! Ȃ۸т̿ĳ\̧̂ق̋@\IȐɒuĂB
//!
//! @version 1.1 pwm3-ac-ctrl-motor-0_0_6
//!
//! @todo
//! @bug
//**************************************************************************

//_____ ݸٰ _______________________________________________________________

#include "config.h"
#include "lib_mcu\dali\dali_code.h"
#include "lib_mcu\dali\dali_lib.h"

extern volatile U16 fosc;

//--------------------------------------------------------------------------
//  @fn dali_slave_init
//!
//! DALI SLAVEӋ@\BӋ@\ؾĂďAĂ܂B
//!
//! @warning	Ȃ
//!
//! @param		Ȃ
//!
//! @return		Status
//!				==TRUE:		@\s
//!				==FALSE:	@\͎s܂B
//!
//--------------------------------------------------------------------------
Bool dali_slave_init(void)
{
  return Dali_slave_init(fosc);
}

//--------------------------------------------------------------------------
//  @fn dali_slave_disable
//!
//! DALI SLAVEӋ@\֎~B֎~ĎMɏՕ܂B
//!
//! @warning	Ȃ
//!
//! @param		Ȃ
//!
//! @return		Ȃ
//!
//--------------------------------------------------------------------------
void dali_slave_disable(void)
{
  Dali_slave_disable();
}

//--------------------------------------------------------------------------
//  @fn dali_slave_enable
//!
//! DALI SLAVEӋ@\BȂŋ܂B
//!
//! @warning	ȑO'dali_slave_init()'sȂ΂Ȃ܂B
//!
//! @param		Ȃ
//!
//! @return		Ȃ
//!
//--------------------------------------------------------------------------
void dali_slave_enable(void)
{
  Dali_slave_enable(fosc);
}

//--------------------------------------------------------------------------
//  @fn dali_slave_cmd
//!
//! ̊֐DALI SLAVELqq擾Asׂ(MAMA~(܂͂Ȃ
//! ))𕪐͂܂B
//! ̊֐͏DALI_CMD_ACCEPTED܂͉肪NꍇDALI_CMD_REFUSED
//! ԂȀꍇAp͌ōĎsȂ΂Ȃ܂B
//!
//! @param	st_dali_slave_mess_t* - sׂI邽߂DALI SLAVEү
//!									Lqq\߲̂
//!
//! @return	DALI_CMD_ACCEPTED - ߂͎󂯓܂B
//!			DALI_CMD_REFUSED  - ߂͋₳܂B
//!
//--------------------------------------------------------------------------
U8 dali_slave_cmd (st_dali_slave_mess_t*  st_mess)
{
  switch (st_mess->cmd)
  {
	case CMD_NONE:
	  return DALI_CMD_ACCEPTED;
	  break;

	case CMD_RX_CMD:
	  st_mess->handle = 0;
	  //- 'st_mess->cmd'"dali_lib.h"Œ񎦂߂1ƋɎ剞p۸тɂ
	  //  ďȂ΂Ȃ܂B
	  //- 'st_mess->short_add'DALIKi̕ϐ̕\ŋLq悤6ޯĂ̐'SH
	  //  ORT_ADDRESS'ƋɎ剞p۸тɂďȂ΂Ȃ܂B
	  //- 'st_mess->group'DALIKi̕ϐ̕\ŋLq悤'GROUP 8-15''G
	  //  ROUP 0-7'̘AƋɎ剞p۸тɂďȂ΂Ȃ܂B
	  st_mess->g_code = NO_DALI_COMMAND_CODE;
	  st_mess->p_cc = 0;							// "O̖ߕ"
	  dali_slave_enable();
	  return DALI_CMD_ACCEPTED;
	  break;

	case CMD_ABORT:
	  dali_slave_disable();
	  st_mess->handle = 0;
	  st_mess->g_code = NO_DALI_COMMAND_CODE;
	  st_mess->p_cc = 0;
	  return DALI_CMD_ACCEPTED;
	  break;

	case CMD_TX_ANSWER:
	  st_mess->handle = 0;
	  st_mess->g_code = NO_DALI_COMMAND_CODE;
	  st_mess->p_cc = 0;
	  //- 'st_mess->dtr'͎剞pɂďȂ΂Ȃ܂B
	  dali_slave_enable();
	  Dali_slave_put(st_mess->dtr);
	  return DALI_CMD_ACCEPTED;
	  break;

	default:
	  return DALI_CMD_REFUSED;
	  break;
  }
}

//--------------------------------------------------------------------------
//  @fn dali_slave_get_status
//!
//! ̊֐͖߂sꂽۂԂƂ܂BM̏ꍇA\̂DA
//! LIүނi[܂B̊֐DALILqq(DALI_TX_COMPLETED,
//! DALI_RX_CODE_xyz, DALI_RX_2ND_CODE_NEEDED_xyz, DALI_RX_QUERY_xyz,
//! DALI_RX_COM_ERROR, DALI_RX_NO_ADD_TYPE, DALI_RX_ADD_OUT_RANGE, ܂
//! DALI_RX_CODE_ERROR)XV܂B
//!
//! @param	st_dali_slave_mess_t*		DALI SLAVELqq\߲̂
//!
//! @return	DALI_STATUS_COMPLETED		- M܂͎M܂B
//!			DALI_STATUS_NOT_COMPLETED	- M܂͎M܂łB
//!			DALI_STATUS_ERROR			- `Ԑݒ܂DALIʐMłُ̈
//!
//--------------------------------------------------------------------------
U8 dali_slave_get_status (st_dali_slave_mess_t* st_mess)
{
  Bool direct_cmd;
  Bool special_cmd;
  U8   code_type;
  U8   add_type;
  U8   rec_add;
  U8   rec_data;
  U16  rec_dali;

//----- 'Handle'is - DALIʐMtɎgp
  st_mess->handle += 1;								// Time_countis

//----- CMD_TX_ANSWER ?
  if (st_mess->cmd == CMD_TX_ANSWER)
  {
	st_mess->p_cc = 0;
	//- CMD_TX_ANSWEȐԂ擾
	if (Dali_slave_tx_done()==TRUE)
	{
	  st_mess->status = DALI_TX_COMPLETED;
	  dali_slave_disable();
	  return DALI_STATUS_COMPLETED;
	}
	else return DALI_STATUS_NOT_COMPLETED;
  }

//----- DALIʐM擾
  if (Dali_slave_rx_ready())
  {
	rec_dali = Dali_slave_get();					// MSB='ڽ ޲', LSB='ް ޲'
	//- ʐMُ퐧
	if ((DALI_SLAVE_RX_ERROR & DALI_RX_COM_ERROR_MASK) != DALI_RX_NO_COM_ERROR)
	{
	  st_mess->p_cc = 0;
	  st_mess->dtr = DALI_SLAVE_RX_ERROR;			// KvȂޯޗp
	  st_mess->status = DALI_RX_COM_ERROR;
	  Dali_slave_disable();
	  return DALI_STATUS_ERROR;
	}
//	rec_dali = Dali_slave_get();					// MSB='ڽ ޲', LSB='ް ޲'
  }
  else return DALI_STATUS_NOT_COMPLETED;

//----- address_test
  direct_cmd = FALSE;								// 
  if ((rec_dali & 0x0100) == 0) direct_cmd = TRUE;

//----- Short_Group_Broadcast_Address_Test
  add_type = NO_ADD_TYPE;							// 
  special_cmd = FALSE;								// 
  rec_add = (rec_dali >> 9);

  // 'rec_add'ɒ: 7ޯĕϐ(rec_add=(rec_dali>>9))
  if ((rec_add & 0x40) == 0) add_type = SHORT_ADD_TYPE;
  else
  {
	// 'rec_add'ɒ: 7ޯĕϐ
	if ((rec_add & 0x70) == 0x40) add_type = GROUP_ADD_TYPE;
	else
	{
	  // 'rec_add'ɒ: 7ޯĕϐ
	  if ((rec_add & 0x7F) == 0x7F) add_type = BROAD_ADD_TYPE;
	  else
	  {
		// ꖽ߂͍L施߂łB
		// 'rec_add'ɒ: 7ޯĕϐ
		if ( (((rec_add & 0x70) == 0x50) || ((rec_add & 0x70) == 0x60)) && (direct_cmd == FALSE) )
		{
		  add_type = BROAD_ADD_TYPE;
		  special_cmd = TRUE;
		}
		else
		{
		  st_mess->p_cc = 0;
		  st_mess->dtr = rec_add;					// KvȂޯޗp: 7ޯĕϐ
		  st_mess->status =  DALI_RX_NO_ADD_TYPE;
		  Dali_slave_disable();
		  return DALI_STATUS_ERROR;
		}
	  }
	}
  }

//----- Address_Range_Test
  if (add_type != BROAD_ADD_TYPE)
  {
	if (add_type == SHORT_ADD_TYPE)
	{
	  // 'rec_add'ɒ: 7ޯĕϐ
	  if ((st_mess->short_add) != rec_add)
	  {
		st_mess->p_cc = 0;
		st_mess->dtr = rec_add;						// KvȂޯޗp
		st_mess->status =  DALI_RX_ADD_OUT_RANGE;
		Dali_slave_disable();
		return DALI_STATUS_ERROR;
	  }
	}
	else
	{
	  // 'rec_add'ɒ: 7ޯĕϐ
	  if (((st_mess->group) & (1 << (rec_add & 0x0F))) == 0)
	  {
		st_mess->p_cc = 0;
		st_mess->dtr = rec_add & 0x0F;				// KvȂޯޗp
		st_mess->status = DALI_RX_ADD_OUT_RANGE;
		Dali_slave_disable();
		return DALI_STATUS_ERROR;
	  }
	}
  }

//----- Get-Command_Code (dali_lib.ḩَQ)
  rec_data = (U8)(rec_dali & 0x00FF);

  // ڌʌd͐䖽ߏo
  if (direct_cmd == TRUE)
  {
	st_mess->p_cc = 0;
	st_mess->dtr = rec_data;
	st_mess->g_code = DIRECT_ARC_POWER_CONTROL;
	if      (add_type == SHORT_ADD_TYPE) st_mess->status = DALI_RX_CODE_SHORT ;
	else if (add_type == GROUP_ADD_TYPE) st_mess->status = DALI_RX_CODE_GROUP ;
	else                                 st_mess->status = DALI_RX_CODE_BROAD ;
	Dali_slave_disable();
	return DALI_STATUS_COMPLETED;
  }

  if (special_cmd == FALSE)
  {
	// : Ԑڌʌd͐䖽
	if      (  (rec_data >= ((U8)(IMMEDIATE_OFF & 0xFF))) && (rec_data <= ((U8)(ON_AND_STEP_UP & 0xFF))) )
			{   code_type = CT01; }
	else if ( ((rec_data & 0xF0) == ((U8)(GO_TO_SCENE & 0xFF))) )
			{   code_type = CT02; }
	// : `Ԑݒ薽 (2xMȂ΂Ȃ܂B"CMD_RX_CMD_2ND"Q)
	else if (  (rec_data == ((U8)(RESET & 0xFF))) || (rec_data == ((U8)(STORE_ACTUAL_DIM_LEVEL_IN_DTR & 0xFF))) )
			{   if (rec_dali == st_mess->p_cc) code_type = CT01; else code_type = CT11;}
	else if (  (rec_data >= ((U8)(STORE_THE_DTR_AS_MAX_LEVEL & 0xFF))) && (rec_data <= ((U8)(STORE_THE_DTR_AS_FADE_RATE & 0xFF))) )
			{   if (rec_dali == st_mess->p_cc) code_type = CT01; else code_type = CT11;}
	else if ( ((rec_data & 0xF0) >= ((U8)(STORE_THE_DTR_AS_SCENE & 0xFF))) && ((rec_data & 0xF0) <= ((U8)(REMOVE_FROM_GROUP & 0xFF))) )
			{   if (rec_dali == st_mess->p_cc) code_type = CT02; else code_type = CT12;}
	else if (  (rec_data == ((U8)(STORE_DTR_AS_SHORT_ADDRESS & 0xFF))) )
			{   if (rec_dali == st_mess->p_cc) code_type = CT01; else code_type = CT11;}
	// : ▽ (KvB"CMD_TX_ANSWER"Q)
	else if ( (rec_data >= ((U8)(QUERY_STATUS & 0xFF))) && (rec_data <= ((U8)(QUERY_POWER_FAILURE & 0xFF))) )
			{   code_type = CT21; }
	else if (  (rec_data >= ((U8)(QUERY_ACTUAL_LEVEL & 0xFF))) && (rec_data <= ((U8)(QUERY_FADE & 0xFF))) )
			{   code_type = CT21; }
	else if (  ((rec_data & 0xF0) == ((U8)(QUERY_SCENE_LEVEL & 0xFF))) )
			{   code_type = CT22; }
	else if (  (rec_data >= ((U8)(QUERY_GROUPS_0_7 & 0xFF))) && (rec_data <= ((U8)(QUERY_RANDOM_ADDRESS_L & 0xFF))) )
			{   code_type = CT21; }
	else if ( ((rec_data & 0xE0) == ((U8)(QUERY_APPLICATION_EXTENTED_COMMAND & 0xFF))) )
			{   code_type = CT23; }		// '0xE0'Ɋւ, QUERY_APPLICATION_EXTENTED_COMMANDɑ΂WߕmF܂B
	else	{   code_type = CT00; }
  }
  else												// special_cmd==TRUE
  {
	// : ꖽ
	if      (   rec_dali == TERMINATE)
			{   code_type = CT09; }
	else if ( ((rec_dali & 0xFF00) == DATA_TRANSFER_REGISTER) || ((rec_dali & 0xFF00) == INITIALISE) )
			{   code_type = CT0D; }
	else if ( ( rec_dali == RANDOMISE) || ( rec_dali == COMPARE)  || ( rec_dali == WITHDRAW) )
			{   code_type = CT09; }
	else if ( ((rec_dali & 0xFF00) == SEARCHADDRH) || ((rec_dali & 0xFF00) == SEARCHADDRM) || ((rec_dali & 0xFF00) == SEARCHADDRL) )
			{   code_type = CT0D; }
	else if ( ((rec_dali & 0xFF81) == (PROGRAM_SHORT_ADDRESS+1)) || ((rec_dali & 0xFF81) == (VERIFY_SHORT_ADDRESS+1)) )
			{   code_type = CT0C; }
	else if (   rec_dali == QUERY_SHORT_ADDRESS )
			{   code_type = CT29; }
	else if (   rec_dali == PHYSICAL_SELECTION )
			{   code_type = CT09; }
	else if ( ((rec_dali & 0xFF00) == ENABLE_DEVICE_TYPE_X) )
			{   code_type = CT0D; }
	else	{   code_type = CT00; }
  }

//----- үލ\̂Ɩ߂lXV
  // CT100pүލ\̂Ɩ߂lXV
  if (code_type == CT00)
  {
	st_mess->g_code = NO_DALI_COMMAND_CODE;
	st_mess->dtr = rec_add;							// KvȂޯޗp
	st_mess->p_cc = 0;
	st_mess->status = DALI_RX_CODE_ERROR;
	Dali_slave_disable();
	return DALI_STATUS_ERROR;
  }

  // үލ\̂̍XV̂
  switch (code_type & 0x0F)
  {
	case CTX1:
	  st_mess->g_code = ((U16)(rec_data)) | 0x0100;
	  st_mess->dtr = 0;
	  break;

	case CTX2:
	  st_mess->g_code = ((U16)(rec_data & 0xF0)) | 0x0100;
	  st_mess->dtr = rec_data & 0x0F;
	  break;

	case CTX3:
	  st_mess->g_code = ((U16)(rec_data & 0xE0)) | 0x0100;	// '0xE0'Ɋւ, WߕꗗmF
	  st_mess->dtr = rec_data & 0x1F;						// '0x1F'Ɋւ, WߕꗗmF
	  break;

	case CTX9:
	  st_mess->g_code = rec_dali;
	  st_mess->dtr = 0;
	  break;

	case CTXC:
	  st_mess->g_code = (rec_dali & 0xFF00);
	  st_mess->dtr = rec_data >> 1;
	  break;

	case CTXD:
	  st_mess->g_code = (rec_dali & 0xFF00);
	  st_mess->dtr = rec_data;
	  break;

	default:	// ܂! ɂ̺ނKvłB
	  st_mess->g_code = NO_DALI_COMMAND_CODE;
	  st_mess->p_cc = st_mess->dtr = 0;
	  st_mess->status = DALI_RX_CODE_ERROR;
	  Dali_slave_disable();
	  return DALI_STATUS_ERROR;
	  break;
  }

  // үލ\̂̍XV̂
  switch (code_type & 0xF0)
  {
	case CT0X:		// 
	  st_mess->p_cc = 0;				// ǂ炩ƌΒODALIߕؾ
	  if      (add_type == SHORT_ADD_TYPE) st_mess->status = DALI_RX_CODE_SHORT;
	  else if (add_type == GROUP_ADD_TYPE) st_mess->status = DALI_RX_CODE_GROUP;
	  else                                 st_mess->status = DALI_RX_CODE_BROAD;
	  Dali_slave_disable();
	  return  DALI_STATUS_COMPLETED;
	  break;

	case CT1X:		// `Ԑݒ
	  st_mess->p_cc = rec_dali;			// ODALIߕ̋L^
	  st_mess->handle = 0;				// Time-countؾ
	  if      (add_type == SHORT_ADD_TYPE) st_mess->status = DALI_RX_2ND_CODE_NEEDED_SHORT;
	  else if (add_type == GROUP_ADD_TYPE) st_mess->status = DALI_RX_2ND_CODE_NEEDED_GROUP;
	  else                                 st_mess->status = DALI_RX_2ND_CODE_NEEDED_BROAD;
	  return  DALI_STATUS_NOT_COMPLETED;
	  break;

	case CT2X:		// 
	  st_mess->p_cc = 0;				// ǂ炩ƌΒODALIߕؾ
	  st_mess->handle = 0;				// Time-countؾ
	  if      (add_type == SHORT_ADD_TYPE) st_mess->status = DALI_RX_QUERY_SHORT;
	  else if (add_type == GROUP_ADD_TYPE) st_mess->status = DALI_RX_QUERY_GROUP;
	  else                                 st_mess->status = DALI_RX_QUERY_BROAD;
	  Dali_slave_disable();
	  return  DALI_STATUS_COMPLETED;
	  break;

	default:	// ܂! ɂ̺ނKvłB
	  st_mess->g_code = NO_DALI_COMMAND_CODE;
	  st_mess->p_cc = st_mess->dtr = 0;
	  st_mess->status = DALI_RX_CODE_ERROR;
	  Dali_slave_disable();
	  return DALI_STATUS_ERROR;
	  break;
  }
  // ʓIɁABȂ!
  Dali_slave_disable();
  return DALI_STATUS_ERROR;
}
