//**************************************************************************
//! @file dali_lib.h,v
//!
//! Copyright (c) 2005 Atmel.
//!
//! 쌠ʒmɂĂlicense.txţقǂłB
//!
//! @brief ̧قDEVICE TYPE 0p̧̂قDEVICE TYPE 0Ɋւėp\
//!		   DALIײ ٰ݂̌^ϸۂ܂݂܂B
//!
//! @version 1.1 pwm3-ac-ctrl-motor-0_0_6
//!
//! @todo
//! @bug
//**************************************************************************


#ifndef _DALI_LIB_H_
#define _DALI_LIB_H_

// _____(EUSARTł̊蓖)__________________________________________________
#include "lib_mcu/eusart/eusart_drv.h"
#include "lib_mcu/eusart/eusart_lib.h"

//_____ `Ԑݒ ______________________________________________________________

//_____ ` __________________________________________________________________

// @brief ̒萔ُ͈̏ʐMُ퐧޲ĂłB
#define DALI_RX_NO_COM_ERROR		0x03
#define DALI_RX_COM_ERROR_MASK		0XEF	// FEُ킪邩܂B

// @brief ̒萔"can_cmd"@\ɑ΂߂lƂĎgp܂B
#define DALI_CMD_REFUSED			0xFF
// ----------
// @brief ̒萔"can_cmd"@\ɑ΂߂lƂĎgp܂B
#define DALI_CMD_ACCEPTED			0x00

// ----------
// @brief ̒萔"can_get_status"@\ɑ΂߂lƂĎgp܂B
#define DALI_STATUS_COMPLETED		0x00
// ----------
// @brief ̒萔"can_get_status"@\ɑ΂߂lƂĎgp܂B
#define DALI_STATUS_NOT_COMPLETED	0x01
// ----------
// @brief ̒萔"can_get_status"@\ɑ΂߂lƂĎgp܂B
#define DALI_STATUS_ERROR			0x02
// ----------
// @brief ̒萔DALIڽ̌``̂Ɏgp܂B
#define SHORT_ADD_TYPE				0x00
#define GROUP_ADD_TYPE				0x40
#define BROAD_ADD_TYPE				0x7F
#define NO_ADD_TYPE					0xFF
// ----------
// @brief ̒萔DALIߕ̌``̂Ɏgp܂B
#define CT00	0x00	// \񖽗ߕ܂͖ߕłȂ, st_mess->dtr=0
#define CT01	0x01	// st_mess->code=( rec_data|0x0100), st_mess->dtr=0
#define CT02	0x02	// st_mess->code=((rec_data&0xF0)|0x0100), st_mess->dtr=(rec_data&0x0F)
#define CT11	0x11	// st_mess->code=( rec_data|0x0100), st_mess->dtr=0, 2xMȂ΂Ȃ܂B
#define CT12	0x12	// st_mess->code=((rec_data&0xF0)|0x0100), st_mess->dtr=(rec_data&0x0F), 2xMȂ΂Ȃ܂B
#define CT21	0x21	// st_mess->code=( rec_data|0x0100), st_mess->dtr=0, ▽
#define CT22	0x22	// st_mess->code=((rec_data&0xF0)|0x0100), st_mess->dtr=(rec_data&0x0F), ▽
#define CT23	0x23	// st_mess->code=((rec_data&0xC0)|0x0100), st_mess->dtr=(rec_data&0x3F), ▽
#define CT09	0x09	// st_mess->code=( rec_dali), st_mess->dtr=0
#define CT0C	0x0C	// st_mess->code=( rec_dali&0xFF00), st_mess->dtr=(rec_data>>1)
#define CT0D	0x0D	// st_mess->code=( rec_dali&0xFF00), st_mess->dtr=rec_data
#define CT29	0x29	// st_mess->code=( rec_dali), st_mess->dtr=0, ▽
    // -----
#define CTX1	0x01	// үލ\̂̍XV̂
#define CTX2	0x02	// үލ\̂̍XV̂
#define CTX3	0x03	// үލ\̂̍XV̂
#define CTX9	0x09	// үލ\̂̍XV̂
#define CTXC	0x0C	// үލ\̂̍XV̂
#define CTXD	0x0D	// үލ\̂̍XV̂
    // -----
#define CT0X	0x00	// RX_CODE߂l̂
#define CT1X	0x10	// 2ND_CODE_NEEDED߂l̂
#define CT2X	0x20	// RX_QUERY߂l̂

// ----------
// @brief ̗񋓂st_dali_slave_mess_t\̂Ő錾ꂽүނɑ΂銈
//		  IԂ̂Ɏgp܂B
typedef enum {
  CMD_NONE,
  CMD_RX_CMD,
  CMD_TX_ANSWER,
  CMD_ABORT
} en_com_cmd_t;

// ----------
// @brief ̗񋓂st_dali_slave_mess_t\̂"dali_slave_get_status()"
//		  ׸ނɎgp܂B
typedef enum {
  NO_STATUS,
  DALI_TX_COMPLETED,
  DALI_RX_CODE_SHORT,
  DALI_RX_CODE_GROUP,
  DALI_RX_CODE_BROAD,
  DALI_RX_2ND_CODE_NEEDED_SHORT,
  DALI_RX_2ND_CODE_NEEDED_GROUP,
  DALI_RX_2ND_CODE_NEEDED_BROAD,
  DALI_RX_QUERY_SHORT,
  DALI_RX_QUERY_GROUP,
  DALI_RX_QUERY_BROAD,
  DALI_RX_COM_ERROR,
  DALI_RX_NO_ADD_TYPE,
  DALI_RX_ADD_OUT_RANGE,
  DALI_RX_CODE_ERROR
} en_status_t;

// ----------
// @brief үދLqq\̂͏]uɑ΂DALIԂł̓ꊈ̒`
//		  ܂B
//
//  1) handle:		Time_count
//  2) cmd:			IԂ߂ɉpɂď
//  3) short_add:	short_addressh߂邽߂ɉpɂďADALI
//					KiŒ`"short_address"ϐłB
//  4) group:		ڽՕƂĉpɂďADALIKiŒ`
//					"group_8_15,group_0_7"ϐłB(16ޯ ްŊeޯ=
//					'1'͌QԍAgroup_0ɑ΂ޯ0Agroup_1ɑ΂ޯ1Ȃ
//					܂B)
//  5) code:		"dali_code.h"DALIߕQ
//  6) p_cc:		2ND_CODE_NEEDEDmFɎgp"O̖ߕ"
//  7) dtr:			ްMpDALI"ް]ڼ޽"
//  8) status:		DALIʐM
typedef  struct{
  U8			handle;
  en_com_cmd_t	cmd;
  U8			short_add;
  U16			group;
  U16			g_code;
  U16			p_cc;
  U8			dtr;
  en_status_t	status;
} st_dali_slave_mess_t;

//_____ 錾 ___(EUSARTŊ蓖)_____________________________________________
#define DALI_SLAVE_RX_ERROR		eusart_rx_error

//_____ ϸ _____(EUSARTŊ蓖)____________________________________________
#define Dali_slave_init(fosc)	( eusart_init(MSK_EUSART_TX_8BIT,MSK_EUSART_RX_16BIT, MANCHESTER, \
                                            MSB_FIRST, fosc, 1200, PARITY_NONE, 2, 2) )
//#define Dali_slave_disable()	( eusart_disable() )
#define Dali_slave_disable()	( eusart_clear() )
//#define Dali_slave_enable()	( eusart_enable()  )
#define Dali_slave_enable(fosc)	( eusart_init(MSK_EUSART_TX_8BIT,MSK_EUSART_RX_16BIT, MANCHESTER, \
                                              MSB_FIRST, fosc, 1200, PARITY_NONE, 2, 2) )
#define Dali_slave_tx_done()	( eusart_tx_done() )
#define Dali_slave_rx_ready()	( eusart_rx_ready())
#define Dali_slave_get()		( eusart_get()     )
#define Dali_slave_put(u8)		( eusart_put((U16)(u8)))

//_____ ^ __________________________________________________________________

//--------------------------------------------------------------------------
//  @fn dali_slave_init
//!
//! DALI]uӋ@\BӋ@\ؾĂďAċ܂B
//!
//! @warning	Ȃ
//!
//! @param		Ȃ
//!
//! @return		
//!				==TRUE:		@\s
//!				==FALSE:	@\͎s܂B
//!
extern Bool dali_slave_init(void);

//--------------------------------------------------------------------------
//  @fn dali_slave_disable
//!
//! DALI]uӋ@\֎~BMɏՕ֎~ĉ܂B
//!
//! @warning	Ȃ
//!
//! @param		Ȃ
//!
//! @return		Ȃ
//!
extern void dali_slave_disable(void);

//--------------------------------------------------------------------------
//  @fn dali_slave_enable
//!
//! DALI]uӋ@\BȂŋB
//!
//! @warning	ȑO'dali_slave_init()'sȂ΂Ȃ܂B
//!
//! @param		Ȃ
//!
//! @return		Ȃ
//!
extern void dali_slave_enable(void);

//--------------------------------------------------------------------------
//  @fn dali_slave_cmd
//!
//! ̊֐DALI]uLqq擾Asׂ(MAMA~)𕪐͂
//! ܂B̊֐͑M܂͎MpMObꍇɏ(CAN_CMD_ACCEPTED
//! ܂CAN_CMD_REFUSED)ԂAp͌ɍĎsȂ΂Ȃ܂B
//! ̊֐͑M܂͎MpMObꍇCANLqq(MOB_PENDING
//! MOB_NOT_REACHED)XV܂B~sꂽꍇACANLqqԂ
//! STATUS_CLEAREDɐݒ肳܂B
//!
//! @param	st_dali_slave_mess_t*	- sׂIԂ߂DALI]uLqq
//!									  \̂Can_descriptor߲
//!
//! @return	CAN_CMD_ACCEPTED		- ߂͎󂯓܂B
//!			CAN_CMD_REFUSED			- ߂͋₳܂B
//!
extern U8 dali_slave_cmd (st_dali_slave_mess_t *);

//--------------------------------------------------------------------------
//  @fn dali_slave_get_status
//!
//! ̊֐͖߂sꂽۂԂƂ܂BM̏ꍇASĂCAN
//! үނ\̂Ɋi[܂B̊֐CANLqq(MOB_TX_COMPLETED,
//!  MOB_RX_COMPLETED, MOB_RX_COMPLETED_DLCW or MOB_???_ERROR)XV܂B
//!
//! @param	st_dali_slave_mess_t*		- DALI]uLqq\߲̂
//!
//! @return	CAN_STATUS_COMPLETED		- M܂͎M܂B
//!			CAN_STATUS_NOT_COMPLETED	- M܂͎M܂łB
//!			CAN_STATUS_ERROR			- `Ԑݒ܂CANʐMłُ̈
//!
extern U8 dali_slave_get_status (st_dali_slave_mess_t *);

//__________________________________________________________________________

#endif // _DALI_LIB_H_
